%define		pname vpopmail
%define		pversion 5.4.33
%define 	bversion 207
%define		rpmrelease iworx
%define 	vdir /home/vpopmail
%define 	vuid 108
%define 	vgid 104
%define 	qdir /var/qmail
%define		iworxdir /home/interworx

%define 	debug_package %{nil}

%define __strip /bin/true

# Distro Statements
%define		oscode rhe%{?rhel}x

%if 0%{?rhel} <= 7
%define 	ostype RedHat Enterprise %{?rhel}.x
%endif


%if 0%{?rhel} >= 8
%define 	ostype Almalinux %{?rhel}.x
%endif

%define	release %{bversion}.%{oscode}.%{rpmrelease}

%if 0%{?rhel} <= 6
Requires:   	vixie-cron
%endif

%if 0%{?rhel} <= 7
BuildRequires:	qmail >= 1.03
Requires:	    qmail >= 1.03
%endif

%if 0%{?rhel} >= 7
%define         ccflags %{optflags} -I%{iworxdir}/include/mysql
%define         ldflags %{optflags} -L%{iworxdir}/lib/mysql -L/usr/lib/x86_64-redhat-linux5E/lib64 -lmysqlclient -lm
%endif

%if 0%{?rhel} >= 8
#Needed temporarily because our qmail would not build without vpopmail and vpopmail needed qmail installed. Created interworx-prep-vpopmail with net-qmail.
BuildRequires:  interworx-prep-vpopmail
Requires:	qmail >= 1.03
%endif

%ifarch x86_64
%define		iworxmysqllibdir %{iworxdir}/mysql/usr/lib64/mysql
%else
%define		iworxmysqllibdir %{iworxdir}/mysql/usr/lib/mysql
%endif

%define		ccflags %{optflags} -I%{iworxdir}/mysql/usr/include/mysql
%define		ldflags %{optflags} -L%{iworxmysqllibdir} -lpthread -lm -lrt -lssl -lcrypto -ldl

BuildRequires:  pam-devel
BuildRequires:  shadow-utils
BuildRequires:	ucspi-tcp >= 0.88
BuildRequires:  openssl-devel
BuildRequires: 	zlib-devel
BuildRequires: 	interworx-unix-users
BuildRequires:  iworx-db-server
Requires:       shadow-utils
Requires:	    ucspi-tcp >= 0.88
Requires(pre):  interworx-unix-users
Requires:       interworx-unix-users
Requires(pre):  iworx-db-server
Requires:       iworx-db-server

############### RPM ################################

Summary:	Vpopmail - Virtual email management system
Name:		%{pname}
Version:	%{pversion}
Release:	%{release}
License:	GPL

Group:		Networking/Other
Source0:	vpopmail-%{pversion}.tar.gz
URL:		http://www.inter7.com/vpopmail

Distribution:	InterWorx-HAL
Vendor:         INTERWORX L.L.C
Packager:	Paul Oehler <poehler@interworx.com>

Epoch:          1

BuildRoot:	%{_tmppath}/%{name}-%{version}-root

Conflicts:     checkpassword
Obsoletes:	   vpopmail-toaster

Patch0:		vpopmail-5.4.33-skip-root-check.iworx.patch
Patch1:		vpopmail-5.4.33-trashquota.iworx.patch
Patch2:		vpopmail-5.4.33-string_list_add-error.patch
Patch3:		vpopmail-5.4.33-pw_passwd-length.patch
Patch4:     vpopmail-5.4.33-jgreylist.patch
Patch5:     vpopmail-5.4.33-ip6-lastauth-table.patch
Patch6:     vpopmail-5.4.33-order-valias-line.patch
Patch7:     vpopmail-5.4.33-relay-ip-length.patch
Patch8:     vpopmail-5.4.33-stop-looping-bounce-messages.patch

%description
vpopmail (vchkpw)  is a collection  of programs  and a library to automate
the creation and maintence of virtual domain email for qmail installations
using either a single UID/GID, or any valid  UID/GID in /etc/passwd with a
home directory. All the  features  are  provided  in the library for other
applications which need to maintain virtual domain email accounts.
It supports named or IP based domains.  It works with vqadmin, qmailadmin,
vqregister, sqwebmail, and courier-imap.
It supports MySQL,  Sybase,  Oracle,  LDAP,  and  file-based (DJB constant
database) authentication.
It handles 10 to 10 million users, and over 500K domains.

%package	doc
Summary:	Vpopmail documentation
Group:		Documentation
Obsoletes:	vpopmail-toaster-doc

%description	doc
Vpopmail  documentation (HTML pages). vpopmail (vchkpw) is a collection of
programs  and a library  to automate the creation and maintence of virtual
domain email for qmail installations.

%prep

%define name vpopmail
%setup -q -n %{name}-%{pversion}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1

# Display compilation flags and OS with colors ;)

if [ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] ; then rm -f %{_tmppath}/%{name}-%{pversion}-show_flags ; fi
cat <<EOF >>%{_tmppath}/%{name}-%{pversion}-show_flags
#!/bin/sh

RPM="RPM RELEASE: \033[40m\033[001;033m%{release}"
OS="OS TYPE IS : \033[40m\033[001;033m%{ostype}"
CCF="CCFLAGS    : \033[40m\033[001;033m%{ccflags}"
LDF="LDFLAGS    : \033[40m\033[001;033m%{ldflags}"

echo
echo
echo -e "\033[40m\033[001;031m\$RPM\033[0m"
echo -e "\033[40m\033[001;031m\$OS\033[0m"
echo -e "\033[40m\033[001;031m\$GCC\033[0m"
echo -e "\033[40m\033[001;031m\$CCF\033[0m"
echo -e "\033[40m\033[001;031m\$LDF\033[0m"
echo
echo

sleep 5

EOF

# Take care to execute and then to delete
chmod u+x %{_tmppath}/%{name}-%{pversion}-show_flags
%{_tmppath}/%{name}-%{pversion}-show_flags
if [ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] ; then rm -f %{_tmppath}/%{name}-%{pversion}-show_flags ; fi

# Patcho il configure ==> Patch the configure

/bin/mkdir -p %{buildroot}/home/vpopmail/etc

cp -pf $RPM_BUILD_DIR/%{name}-%{pversion}/configure $RPM_BUILD_DIR/%{name}-%{pversion}/configure.bkup

# Creo un piccolo file bash ==> create a small bash file

[ -f %{_tmppath}/patch_configure ] && rm -f %{_tmppath}/patch_configure

cat <<EOF >>%{_tmppath}/patch_configure
#!/bin/sh

if [ -f $RPM_BUILD_DIR/%{name}-%{pversion}/configure ]; then
	perl -pi -e 's|\\\$vpopmaildir/etc/lib_deps|%{buildroot}/\\\$vpopmaildir/etc/lib_deps|g' $RPM_BUILD_DIR/%{name}-%{pversion}/configure
	perl -pi -e 's|\\\$vpopmaildir/etc/inc_deps|%{buildroot}/\\\$vpopmaildir/etc/inc_deps|g' $RPM_BUILD_DIR/%{name}-%{pversion}/configure


fi
EOF

chmod u+x %{_tmppath}/patch_configure

%{_tmppath}/patch_configure

[ -f %{_tmppath}/patch_configure ] && rm -f %{_tmppath}/patch_configure

# We have gcc written in a temp file
export CC="gcc %{ccflags}"
%if ! 0%{?rhel} <= 7
export LDFLAGS="%{ldflags}"
%endif

./configure                                 \
    --enable-auth-module=mysql              \
    --enable-non-root-build                 \
	--enable-trashquota=y                   \
	--enable-roaming-users=y                \
	--enable-many-domains=y                 \
	--enable-learn-passwords=y              \
	--enable-mysql-replication=n            \
	--enable-sql-logging=n                  \
	--enable-logging=e                      \
	--enable-qmail-ext=y                    \
	--enable-valias=y                       \
	--enable-passwd=n                       \
	--enable-apop=n                         \
	--enable-incdir=%{iworxdir}/mysql/usr/include/mysql \
	--enable-libdir=%{iworxmysqllibdir}     \
	--enable-tcprules-prog=`which tcprules` \
	--disable-clear-passwd                  \
	--enable-tcpserver-file=%{_sysconfdir}/tcprules.d/tcp.smtp

mv -f $RPM_BUILD_DIR/%{name}-%{pversion}/configure.bkup $RPM_BUILD_DIR/%{name}-%{pversion}/configure

# Script del crontab

[ -d %{buildroot}/%{_sysconfdir}/cron.d ] || mkdir -p %{buildroot}/%{_sysconfdir}/cron.d

if [ -f %{buildroot}/%{_sysconfdir}/cron.d/toaster.vpopmail ] ; then rm -f %{buildroot}/%{_sysconfdir}/cron.d/toaster.vpopmail ; fi

%build

%{__make} %{?_smp_mflags}

%install
# We must patch the Makefile in order to make to install all
# within directory of the RPM (and not in /home/vpopmail)

cp -rf $RPM_BUILD_DIR/%{name}-%{pversion}/Makefile $RPM_BUILD_DIR/%{name}-%{pversion}/Makefile.bkup

[ -f %{_tmppath}/fix_Makefile ] && rm -f %{_tmppath}/fix_Makefile

cat <<EOF >>%{_tmppath}/fix_Makefile
#!/bin/sh

if [ -f $RPM_BUILD_DIR/%{name}-%{pversion}/Makefile ]; then
#	perl -pi -e 's|^DESTDIR\s*=|DESTDIR = %{buildroot}|g' $RPM_BUILD_DIR/%{name}-%{pversion}/Makefile

	echo -e "DESTDIR = %{buildroot}\n" > $RPM_BUILD_DIR/%{name}-%{pversion}/destdir
        cat $RPM_BUILD_DIR/%{name}-%{pversion}/destdir $RPM_BUILD_DIR/%{name}-%{pversion}/Makefile > $RPM_BUILD_DIR/%{name}-%{pversion}/Makefile.new
        mv $RPM_BUILD_DIR/%{name}-%{pversion}/Makefile.new $RPM_BUILD_DIR/%{name}-%{pversion}/Makefile

fi
EOF

# Setto il piccolo file bash eseguibile, lo eseguo, e lo cancello
chmod u+x %{_tmppath}/fix_Makefile
%{_tmppath}/fix_Makefile
[ -f %{_tmppath}/fix_Makefile ] && rm -rf %{_tmppath}/fix_Makefile

%{__make} install

mv -f $RPM_BUILD_DIR/%{name}-%{pversion}/Makefile.bkup $RPM_BUILD_DIR/%{name}-%{pversion}/Makefile

%clean

if [ -f %{_tmppath}/test_vpopmail ]; then
	/usr/sbin/userdel -r vpopmail
	rm -f %{_tmppath}/test_vpopmail
fi

if [ -f %{_tmppath}/test_vchkpw ]; then
	/usr/sbin/groupdel vchkpw
	rm -f %{_tmppath}/test_vchkpw
fi

[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}
[ -d $RPM_BUILD_DIR/%{name}-%{pversion} ] && rm -rf $RPM_BUILD_DIR/%{name}-%{pversion}

%pre

%postun

if [ "$1" = "0" ]; then
  rm -f /etc/cron.d/vpopmail 2>/dev/null || :

  grep -v '* * * * root %{vdir}/bin/clearopensmtp' /etc/crontab > /etc/crontab.new 2>/dev/null || :
  mv -f /etc/crontab.new /etc/crontab
fi

%preun
if [ "$1" == "0" ]; then
   echo
   echo "WARNING: vpopmail package removal request denied.  This package is required by Interworx."
   echo
   exit 1
fi

%post

if ! grep '* * * * root %{vdir}/bin/clearopensmtp' /etc/cron.d/vpopmail > /dev/null 2>&1; then
  echo "" >> /etc/cron.d/vpopmail
  echo "40 * * * * root %{vdir}/bin/clearopensmtp > /dev/null 2>&1" >> /etc/cron.d/vpopmail
fi

if grep '* * * * root %{vdir}/bin/clearopensmtp' /etc/crontab > /dev/null 2>&1; then
  grep -v '* * * * root %{vdir}/bin/clearopensmtp' /etc/crontab > /etc/crontab.new 2>/dev/null || :
  mv -f /etc/crontab.new /etc/crontab
fi

# make sure iworx user has access
chmod 0751 %{vdir}
chmod 0750 %{vdir}/bin
chmod 0750 %{vdir}/bin/*
chmod 0750 %{vdir}/domains

# make sure the suid perms are right
chown vpopmail.vchkpw \
	%{vdir}/bin/vadduser \
	%{vdir}/bin/vdeluser \
	%{vdir}/bin/vdominfo \
	%{vdir}/bin/vmoduser \
	%{vdir}/bin/vpasswd  \
	%{vdir}/bin/valias   \
	%{vdir}/bin/vuserinfo

chmod 4750 \
	%{vdir}/bin/vadduser \
	%{vdir}/bin/vdeluser \
	%{vdir}/bin/vdominfo \
	%{vdir}/bin/vmoduser \
	%{vdir}/bin/vpasswd  \
	%{vdir}/bin/valias

chmod 6750 %{vdir}/bin/vuserinfo

%files doc
%defattr (-,root,root)
%attr(0755,vpopmail,vchkpw) %dir %{vdir}/doc
%attr(0755,vpopmail,vchkpw) %dir %{vdir}/doc/doc_html
%attr(0755,vpopmail,vchkpw) %dir %{vdir}/doc/man_html
%attr(0444,vpopmail,vchkpw) %{vdir}/doc/doc_html/*
%attr(0444,vpopmail,vchkpw) %{vdir}/doc/man_html/*

%files
%defattr (-,vpopmail,vchkpw)
%attr(0711,vpopmail,vchkpw) %dir %{vdir}
%attr(0755,vpopmail,vchkpw) %dir %{vdir}/bin
%attr(0755,vpopmail,vchkpw) %dir %{vdir}/etc
%attr(0755,vpopmail,vchkpw) %dir %{vdir}/include
%attr(0755,vpopmail,vchkpw) %dir %{vdir}/lib
%attr(0700,vpopmail,vchkpw) %dir %{vdir}/domains

%config(noreplace) %{vdir}/etc/vpopmail.mysql

%config(noreplace) %{vdir}/etc/vusagec.conf

%attr(0750,vpopmail,vchkpw) %{vdir}/bin/clearopensmtp
%attr(0750,vpopmail,vchkpw) %{vdir}/bin/vaddaliasdomain
%attr(0750,vpopmail,vchkpw) %{vdir}/bin/vadddomain
%attr(0750,vpopmail,vchkpw) %{vdir}/bin/vchangepw
%attr(0750,vpopmail,vchkpw) %{vdir}/bin/vchkpw
%attr(0750,vpopmail,vchkpw) %{vdir}/bin/vconvert
%attr(0750,vpopmail,vchkpw) %{vdir}/bin/vdeldomain
%attr(0750,vpopmail,vchkpw) %{vdir}/bin/vdelivermail
%attr(0750,vpopmail,vchkpw) %{vdir}/bin/vdeloldusers
%attr(0750,vpopmail,vchkpw) %{vdir}/bin/vipmap
%attr(0750,vpopmail,vchkpw) %{vdir}/bin/vkill
%attr(0750,vpopmail,vchkpw) %{vdir}/bin/vmkpasswd
%attr(0750,vpopmail,vchkpw) %{vdir}/bin/vmoddomlimits
%attr(0750,vpopmail,vchkpw) %{vdir}/bin/vpopbull
%attr(0750,vpopmail,vchkpw) %{vdir}/bin/dotqmail2valias
%attr(0750,vpopmail,vchkpw) %{vdir}/bin/vsetuserquota
%attr(0750,vpopmail,vchkpw) %{vdir}/bin/authvchkpw
%attr(0750,vpopmail,vchkpw) %{vdir}/bin/vlist
%attr(0750,vpopmail,vchkpw) %{vdir}/bin/vpopmaild
%attr(0750,vpopmail,vchkpw) %{vdir}/bin/vusagec

# we need the following set uid

%attr(4750,vpopmail,vchkpw) %{vdir}/bin/vadduser
%attr(4750,vpopmail,vchkpw) %{vdir}/bin/valias
%attr(4750,vpopmail,vchkpw) %{vdir}/bin/vdeluser
%attr(4750,vpopmail,vchkpw) %{vdir}/bin/vdominfo
%attr(4750,vpopmail,vchkpw) %{vdir}/bin/vmoduser
%attr(4750,vpopmail,vchkpw) %{vdir}/bin/vpasswd
%attr(4750,vpopmail,vchkpw) %{vdir}/bin/vuserinfo

%attr(0444,vpopmail,vchkpw) %{vdir}/include/*
%attr(0644,vpopmail,vchkpw) %{vdir}/lib/*
%attr(0644,vpopmail,vchkpw) %{vdir}/etc/inc_deps
%attr(0644,vpopmail,vchkpw) %{vdir}/etc/lib_deps
%attr(0644,vpopmail,vchkpw) %{vdir}/etc/vlimits.default

%changelog
* Wed Dec 28 2022 Brandon Locke <blocke@liquidweb.com>
- Requires modified to use generic iworx-db-server 
* Wed Dec 22 2021 Joseph Purkis <jpurkis@interworx.com>
- Remove ancient dynamic gcc resolution (always resulted in just 'gcc')
- Cleaned up old Distros
* Wed Oct 18 2021 Joseph Purkis <jpurkis@interworx.com>
- Adding Almalinux and cleaning up old rhexs
- Added interworx-prep-vpopmail for details look at interworx-prep-vpopmail notes.
* Mon Oct 11 2021 Tim College <tcollege@interworx.com>
- Add interworx-unix-users package to create unix users
* Tue Apr 27 2021 Nathan Roth <nroth@interworx.com>
- Extend username length to 64 characters
* Tue Feb 26 2019 Paul Oehler <poehler@interworx.com>
- Disable clear passwd storage altogether
* Thu Aug 30 2018 Paul Oehler <poehler@interworx.com>
- Added vpopmail-5.4.33-stop-looping-bounce-messages.patch
* Mon Sep 26 2016 Paul Oehler <poehler@interworx.com>
- Added vpopmail-5.4.33-order-valias-line.patch
* Tue Jun 21 2016 Paul Oehler <poehler@interworx.com>
- Extended lastauth remote_ip length for ipv6 support.
* Wed Mar 30 2016 Paul Oehler <poehler@interworx.com>
- Added jgreylist patch
* Tue Sep 30 2014 Matt Parmelee <mparmelee@interworx.com>
- Changed log level to errors-only.
* Mon Sep 15 2014 Paul Oehler <poehler@interworx.com>
- Updated spec for iworx-db (percona) support.
- Epoch bumped to 1
* Tue Aug 26 2014 Matt Parmelee <mparmelee@interworx.com>
- Updated for RHEL 7.x
* Thu Jan 17 2013 Matt Parmelee <mparmelee@interworx.com>
- Suppressed errors to ease transition to new crondir.
* Wed Jan 09 2013 Matt Parmelee <mparmelee@interworx.com>
- Changed cron directory.
* Tue Jul 03 2012 Paul Oehler <poehler@interworx.com>
- added string_list_add patch.
* Tue Jan 17 2012 Paul Oehler <poehler@interworx.com>
- Upgraded to vpopmail 5.4.33
- Added maildir++ trashquota option
* Wed Sep 28 2011 Paul Oehler <poehler@interworx.com>
- Upgraded to vpopmail 5.4.32
* Wed Oct 13 2010 Paul Oehler <poehler@interworx.com>
- Added vpopmail-5.4.9-adduser-buffer-overflow.patch
* Sun Oct 03 2010 Paul Oehler <poehler@interworx.com>
- Added uninstall blocker preun script
* Thu May 06 2010 Paul Oehler <poehler@interworx.com>
- Updated for RHEL 6.x
* Tue Jun 17 2008 Paul Oehler <poehler@interworx.com>
- Updated for Fedora 9
* Tue May 13 2008 Paul Oehler <poehler@interworx.com>
- Added support for Fedora 8
* Fri Mar 11 2005 Chris Wells <clwells@nexcess.net>
- Updated to 5.4.9
* Tue Feb 08 2005 Chris Wells <clwells@nexcess.net>
- Added fdr30 / fdr40
* Tue Jun 28 2004 Chris Wells <clwells@nexcess.net>
- Initial packaging as part of InterWorx-HAL OS
